unit ModeX;
interface
Procedure SET_VGA_MODEX (Mode, MaxXpos, MaxYpos, Pages : integer);
Procedure SET_MODEX (Mode : integer);
Procedure SET_TEXT;
Procedure CLEAR_VGA_SCREEN (Color : integer);
Procedure SET_POINT (Xpos, Ypos, Color : integer);
Procedure MSET_POINT (Xpos, Ypos, Color : integer);
Function READ_POINT (Xpos, Ypos : integer) : integer;
Procedure FILL_BLOCK (Xpos1, Ypos1, Xpos2, Ypos2, Color : integer);
Procedure MFILL_BLOCK (Xpos1, Ypos1, Xpos2, Ypos2, Color : integer);
Procedure DRAW_LINE (Xpos1, Ypos1, Xpos2, Ypos2, Color : integer);
Procedure DRAW_CIRCLE (Xpos, Ypos, Radius, Color : integer);
Procedure MDRAW_CIRCLE (Xpos, Ypos, Radius, Color : integer);
Procedure FILL_CIRCLE (Xpos, Ypos, Radius, Color : integer);
Procedure MFILL_CIRCLE (Xpos, Ypos, Radius, Color : integer);
Procedure SET_DAC_REGISTER (RegNo, Red, Green, Blue : integer);
Procedure GET_DAC_REGISTER (RegNo : Integer; VAR Red, Green, Blue:integer);
Procedure SET_NORMAL_MODE;
Procedure SET_OR_MODE;
Procedure SET_XOR_MODE;
Procedure SET_AND_MODE;
Procedure SET_ACTIVE_PAGE (PageNo : integer);
Function GET_ACTIVE_PAGE : integer;
Procedure SET_DISPLAY_PAGE (PageNo : integer);
Function GET_DISPLAY_PAGE : integer;
Procedure SET_WINDOW (DisplayPage, XOffset, YOffset : integer);
Function GET_X_OFFSET : integer;
Function GET_Y_OFFSET : integer;
Procedure SYNC_DISPLAY;
Procedure SET_SPLITTED_SCREEN (Line : word);
Procedure GPRINTC (CharNum : Char; Xpos, Ypos, ColorF, ColorB : integer);
Procedure TGPRINTC (CharNum : Char; Xpos, Ypos, ColorF : integer);
Procedure MGPRINTC (CharNum : Char; Xpos, Ypos, ColorF : integer);
Procedure PRINT_STR (Text : string; Xpos, Ypos, ColorF, ColorB : integer);
Procedure TPRINT_STR (Text : string; Xpos, Ypos, ColorF : integer);
Procedure MPRINT_STR (Text : string; Xpos, Ypos, ColorF : integer);
Procedure SET_DISPLAY_FONT (FontData : Pointer; FontNumber : integer);
Procedure DRAW_BITMAP (Image : Pointer; Xpos, Ypos, Width, Height : integer);
Procedure TDRAW_BITMAP (Image : Pointer; Xpos, Ypos, Width, Height : integer);
Procedure MDRAW_BITMAP (Image : Pointer; Xpos, Ypos, Width, Height : integer);
Procedure COPY_PAGE (SourcePage, DestPage : integer);
Procedure COPY_BITMAP (SourcePage, X1, Y1, X2, Y2,
                       DestPage, DestX1, DestY1 : integer);

implementation
{$L modeX.obj}
{$F+}
Procedure SET_VGA_MODEX (Mode, MaxXpos, MaxYpos, Pages : integer); external;
Procedure SET_MODEX (Mode : integer); external;
Procedure SET_TEXT; external;
Procedure CLEAR_VGA_SCREEN (Color : integer); external;
Procedure SET_POINT (Xpos, Ypos, Color : integer); external;
Procedure MSET_POINT (Xpos, Ypos, Color : integer); external;
Function READ_POINT (Xpos, Ypos : integer) : integer; external;
Procedure FILL_BLOCK (Xpos1, Ypos1, Xpos2, Ypos2, Color : integer); external;
Procedure MFILL_BLOCK (Xpos1, Ypos1, Xpos2, Ypos2, Color : integer); external;
Procedure DRAW_LINE (Xpos1, Ypos1, Xpos2, Ypos2, Color : integer); external;
Procedure DRAW_CIRCLE (Xpos, Ypos, Radius, Color : integer);external;
Procedure MDRAW_CIRCLE (Xpos, Ypos, Radius, Color : integer);external;
Procedure FILL_CIRCLE (Xpos, Ypos, Radius, Color : integer);external;
Procedure MFILL_CIRCLE (Xpos, Ypos, Radius, Color : integer); external;
Procedure SET_DAC_REGISTER (RegNo, Red, Green, Blue : integer); external;
Procedure GET_DAC_REGISTER (RegNo : integer; Var Red, Green, Blue : integer); external;
Procedure SET_NORMAL_MODE; external;
Procedure SET_OR_MODE; external;
Procedure SET_XOR_MODE; external;
Procedure SET_AND_MODE; external;
Procedure SET_ACTIVE_PAGE (PageNo : integer); external;
Function GET_ACTIVE_PAGE : integer; external;
Procedure SET_DISPLAY_PAGE (PageNo : integer); external;
Function GET_DISPLAY_PAGE : integer; external;
Procedure SET_WINDOW (DisplayPage, XOffset, YOffset : integer); external;
Function GET_X_OFFSET : integer; external;
Function GET_Y_OFFSET : integer; external;
Procedure SYNC_DISPLAY; external;
Procedure SET_SPLITTED_SCREEN (Line : word);external;
Procedure GPRINTC (CharNum : Char; Xpos, Ypos, ColorF, ColorB : integer); external;
Procedure TGPRINTC (CharNum: Char; Xpos, Ypos, ColorF : integer); external;
Procedure MGPRINTC (CharNum: Char; Xpos, Ypos, ColorF : integer); external;
Procedure PRINT_STR (Text : string ; Xpos, Ypos, ColorF, ColorB : integer);
external;
Procedure TPRINT_STR (Text : string; Xpos, Ypos, ColorF : integer); external;
Procedure MPRINT_STR (Text : string; Xpos, Ypos, ColorF : integer); external;
Procedure SET_DISPLAY_FONT (FontData : Pointer; FontNumber : integer); external;
Procedure DRAW_BITMAP (Image : Pointer; Xpos, Ypos, Width, Height : integer); external;
Procedure TDRAW_BITMAP (Image : Pointer; Xpos, Ypos, Width, Height : integer); external;
Procedure MDRAW_BITMAP (Image : Pointer; Xpos, Ypos, Width, Height : integer); external;
Procedure COPY_PAGE (SourcePage, DestPage : integer); external;
Procedure COPY_BITMAP (SourcePage, X1, Y1, X2, Y2,
                       DestPage, DestX1, DestY1 : integer);external;
{$F-}

end.