UNIT Xlbm;


Interface

Type
 bufT=array[0..64999] of byte;        { defines a 64000byte buffer }
 PbufT=^BufT;                         { just enough for a 320x200 pic }



Var
 LbmPalette:array[0..767] of byte;    { this public buffer holds the palette }
 LbmX : word;                         { Width of the picture }
 LbmY : word;                         { Height of the picture }

Procedure ReadLBM(LBMFilename:string; var destination:pbuft);




Implementation


Procedure ReadLBM(LBMfilename:string; var destination:pbuft);
 Var
  lbmB:byte;             { general byte for FOR-loops etc. }
  lbmW:integer;          { general word for FOR-loops etc. }
  LbmFile:file;          { this is the file to read from }
  LbmBuffer:array[0..999] of byte;  { load 1000bytes a time to save memory }
  Lbm_BufferPos:word;    { tells the reader where to read in 1000byte buffer }
  lbm_writepos:word;     { tells the decoder the current position in the virtual screen }
  lbm_finalpos:word;     { tells the decoder when to stop decoding }

  LastRead:integer;



 Procedure LBM_scanfor(scanstring:string);
 var
  mainpos:word;
  scanpos:word;
  foundpos:boolean;
 begin
  foundpos := false;
  seek(LbmFile, 0);
  Mainpos := 0;
  scanpos := $ffff;
  blockread(lbmfile, lbmbuffer, 504);
  while not foundpos do
  begin
   inc(scanpos);
   if    (lbmbuffer[scanpos] = ord(scanstring[1]))
      and  (lbmbuffer[scanpos+1] = ord(scanstring[2]))
      and  (lbmbuffer[scanpos+2] = ord(scanstring[3]))
      and  (lbmbuffer[scanpos+3] = ord(scanstring[4]))
      then foundpos := true;

  if (not foundpos) and (scanpos>=500) then begin
     seek(lbmfile, filepos(lbmfile)-4);
     inc(mainpos, 500);
     scanpos := $ffff;
     blockread(lbmfile, lbmbuffer, 504);
  end;
 end;

{found the thing, file is in position }
 seek(lbmfile, mainpos+scanpos+4);
 end;



 { gets 1 byte from the file, going through a 1000 byte
   buffer before reading 1000 new bytes }

 Procedure LBMGetByte(var destbyte:byte);
 begin
  if lbm_bufferpos > 999 then
    begin
    lbm_bufferpos := 1;

    if LastRead > 0 then blockread(lbmfile, lbmbuffer, 1000,LastRead);

    Destbyte := lbmbuffer[0];
    end
  else
    begin
    Destbyte := lbmbuffer[lbm_bufferpos];
    inc(lbm_bufferpos);
    end;
 end;


  { main procedure

    Original Version Fehlerhaft... Korrigiert Juni 1997}

 begin
  LastRead := 1;
  assign(LbmFile, LBMFilename);
  reset(Lbmfile, 1);
   {first get dimensions of picture..}
   blockread(lbmfile, lbmbuffer, $18);
   move(lbmbuffer[$14], lbmx, 2);
   move(lbmbuffer[$16], lbmy, 2);
   lbmx := swap(lbmx);
   lbmy := swap(lbmy);

   { go fetch palette }

   LBM_ScanFor('CMAP');
   seek(lbmfile, filepos(lbmfile)+4);  { 4 bytes 'size of block' to skip }
   BlockRead(Lbmfile, LBMPalette, 768);
     { since palette values range 0-255, go shorten them to 0-63 }
   for LBMw := 0 to 767 do lbmpalette[LBMw] := lbmpalette[lbmW] shr 2;

   {then go for the bitmap!}

   LBM_ScanFor('BODY');
   seek(lbmfile, filepos(lbmfile)+4); { skip 4 bytes 'size of block' }

   Lbm_FinalPos := lbmx+lbmy*lbmx;
   Lbm_Writepos := 0;
   Lbm_Bufferpos := $ffff;  { we set this to > 999 so that
                              at first byte fetch we read
                              in 1000 bytes to the buffer }

    while lbm_writepos < lbm_finalpos do
      begin
       LBMGetByte(lbmb);
       if lbmb >= $80 then
         begin  { RLE fill with 1 byte }
          LbmW := LbmB;    { loop LbmW to $0100 and fill with...}
          LbmGetByte(lbmb);  { ...this byte }
          for LbmW := LbmW to $0100 do
           begin
           destination^[lbm_writepos] := lbmb;
           inc (lbm_writepos);
           end;

         end
       else
         begin  { Copy stream of bytes }
         LbmW := LbmB;
         while lbmw >= 0 do
           begin
           LbmGetByte(LbmB); { get a byte from stream... }
           destination^[lbm_writepos] := lbmb;
           inc (lbm_writepos);
           dec (lbmw);
           end;
          end;
        end;
        Close(lbmfile);
        {$i+}
     end;
  end.



